#ifndef GABA_DEFINE
struct dsa_signer
{
  struct signer super;
  struct randomness *random;
  struct dsa_public public;
  mpz_t a;
};
extern struct lsh_class dsa_signer_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_dsa_signer_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct dsa_signer *i = (struct dsa_signer *) o;
  mark((struct lsh_object *) i->random);
  dsa_public_mark(&i->public, mark);
}

static void do_dsa_signer_free(struct lsh_object *o)
{
  struct dsa_signer *i = (struct dsa_signer *) o;
  dsa_public_free(&i->public);
  mpz_clear(i->a);
}

struct lsh_class dsa_signer_class =
{ STATIC_HEADER,
  &signer_class, "dsa_signer", sizeof(struct dsa_signer),
  do_dsa_signer_mark,
  do_dsa_signer_free
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct dsa_signer_variant
{
  struct signer super;
  struct dsa_signer *dsa;
};
extern struct lsh_class dsa_signer_variant_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_dsa_signer_variant_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct dsa_signer_variant *i = (struct dsa_signer_variant *) o;
  mark((struct lsh_object *) i->dsa);
}

struct lsh_class dsa_signer_variant_class =
{ STATIC_HEADER,
  &signer_class, "dsa_signer_variant", sizeof(struct dsa_signer_variant),
  do_dsa_signer_variant_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct dsa_verifier
{
  struct verifier super;
  struct dsa_public public;
};
extern struct lsh_class dsa_verifier_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_dsa_verifier_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct dsa_verifier *i = (struct dsa_verifier *) o;
  dsa_public_mark(&i->public, mark);
}

static void do_dsa_verifier_free(struct lsh_object *o)
{
  struct dsa_verifier *i = (struct dsa_verifier *) o;
  dsa_public_free(&i->public);
}

struct lsh_class dsa_verifier_class =
{ STATIC_HEADER,
  &verifier_class, "dsa_verifier", sizeof(struct dsa_verifier),
  do_dsa_verifier_mark,
  do_dsa_verifier_free
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct dsa_verifier_variant
{
  struct verifier super;
  struct dsa_verifier *dsa;
};
extern struct lsh_class dsa_verifier_variant_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_dsa_verifier_variant_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct dsa_verifier_variant *i = (struct dsa_verifier_variant *) o;
  mark((struct lsh_object *) i->dsa);
}

struct lsh_class dsa_verifier_variant_class =
{ STATIC_HEADER,
  &verifier_class, "dsa_verifier_variant", sizeof(struct dsa_verifier_variant),
  do_dsa_verifier_variant_mark,
  NULL
};
#endif /* !GABA_DECLARE */

#ifndef GABA_DEFINE
struct dsa_algorithm
{
  struct signature_algorithm super;
  struct randomness *random;
};
extern struct lsh_class dsa_algorithm_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_dsa_algorithm_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct dsa_algorithm *i = (struct dsa_algorithm *) o;
  mark((struct lsh_object *) i->random);
}

struct lsh_class dsa_algorithm_class =
{ STATIC_HEADER,
  &signature_algorithm_class, "dsa_algorithm", sizeof(struct dsa_algorithm),
  do_dsa_algorithm_mark,
  NULL
};
#endif /* !GABA_DECLARE */

